# -*- coding: utf-8 -*-
"""
/***************************************************************************
 FourDLinkQgisPlugin
                                 A QGIS plugin
 XXXXXXXXXXXXXXXXXXX
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2022-07-26
        git sha              : $Format:%H$
        copyright            : (C) 2022 by XXX/XXX
        email                : XXX@XXXX
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from pathlib import Path
from zipfile import ZipFile
from math import ceil
from urllib import parse
import mimetypes
import requests
import json
import os
import glob

from qgis.PyQt.QtCore import QSettings, QTranslator, QCoreApplication, Qt
from qgis.core import QgsProject, QgsRasterPipe, QgsRasterLayer, QgsVectorLayer, QgsVectorFileWriter, QgsRasterFileWriter, Qgis
from qgis.gui import QgsMapCanvas
from qgis.PyQt.QtGui import QIcon
from qgis.PyQt.QtWidgets import QAction, QMessageBox, QProgressDialog, QProgressBar, QSizePolicy

# Initialize Qt resources from file resources.py
from .resources import *
# Import the code for the dialog
from .four_d_link_qgis_plugin_dialog import FourDLinkQgisPluginDialog
from .fourdlink import (fetch_access_token, fetch_projects, fetch_group_dataset_by_project, 
                        fetch_dataset_file, fetch_folder, create_dataset)
import os.path


class FourDLinkQgisPlugin:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface
        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(
            self.plugin_dir,
            'i18n',
            'FourDLinkQgisPlugin_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)
            QCoreApplication.installTranslator(self.translator)

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&4DLink_QGIS_Plugin')

        # Check if plugin was started the first time in current QGIS session
        # Must be set in initGui() to survive plugin reloads
        self.first_start = None
        user_folder = Path(os.path.expanduser('~'))
        self.tmp_file_folder = str(user_folder / "qgis-tmp-plugin")

        self.access_token = None
        self.projects = {}
        self.layer_groups = {}
        self.layer_group_dataset_tree = {}
        self.base_map_urls = {
            '国土地理院<標準地図>': 'https://cyberjapandata.gsi.go.jp/xyz/std/{z}/{x}/{y}.png',
            '国土地理院<白地図>': 'https://cyberjapandata.gsi.go.jp/xyz/blank/{z}/{x}/{y}.png'
        }
        self.select_layer_group_id = None
        self.select_folder_id = None
        self.select_dataset_id = None

    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('FourDLinkQgisPlugin', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon =  icon = QIcon(os.path.dirname(__file__)+'/icon.png')
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            # Adds plugin icon to Plugins toolbar
            self.iface.addToolBarIcon(action)

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""

        icon_path = ':/plugins/four_d_link_qgis_plugin/icon.png'
        self.add_action(
            icon_path,
            text=self.tr(u'4DLink_QGIS_Plugin'),
            callback=self.run,
            parent=self.iface.mainWindow())
        # self.action = QAction(QIcon(icon_path), '4DLink_QGIS_Plugin', self.iface.mainWindow())
        # self.iface.addToolBarIcon(self.action)
        # will be set False in run()
        self.first_start = True

    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&4DLink_QGIS_Plugin'),
                action)
            self.iface.removeToolBarIcon(action)

    def run(self):
        """Run method that performs all the real work"""
        # Create the dialog with elements (after translation) and keep reference
        # Only create GUI ONCE in callback, so that it will only load when the plugin is started
        if self.first_start == True:
            os.makedirs(self.tmp_file_folder, exist_ok=True)
            self.remove_tmp_files()

            self.first_start = False
           
            self.dlg = FourDLinkQgisPluginDialog()
            self.dlg.adjustSize()
            self.dlg.rejected.connect(self.close_dialogue)
            self.dlg.auth_button.clicked.connect(self.authenticate_fetch_projects)
            self.dlg.upload_button.clicked.connect(self.upload)
            self.dlg.project_name_form.currentIndexChanged.connect(self.change_projects)
            self.dlg.layer_group_form.currentIndexChanged.connect(self.list_datasets)
            self.dlg.dataset_form.currentIndexChanged.connect(self.change_dataset)
            self.dlg.base_map_form.addItems(list(self.base_map_urls.keys()))
            self.dlg.layer_get_button.clicked.connect(self.list_current_qgis_layers)
            self.dlg.download_button.clicked.connect(self.import_dataset_to_qgis)
            self.dlg.base_map_form.hide()
            self.dlg.base_map_form.currentIndexChanged.connect(self.change_base_map_layer)
            self.dlg.base_map_check_box.stateChanged.connect(self.check_base_map_layer)

            # 一時的
            self.dlg.download_button.setDisabled(True)
            self.dlg.dataset_form.setDisabled(True)
            self.dlg.feature_tab.setTabVisible(0, False)
        # show the dialog
        self.dlg.show()
        # Run the dialog event loop
        result = self.dlg.exec_()
        # See if OK was pressed
        if result:
            # Do something useful here - delete the line containing pass and
            # substitute with your code.
            pass

    def close_dialogue(self):
        print('close')

    def valid_empty_form(self, target_form, title, message):
        if target_form.currentText() == '':
            QMessageBox.information(None, title, message)
            return True
        else:
            return False

    def show_message_by_response(self, response,
                                 success_message, error_message):
        if response.status_code == 200:
            QMessageBox.information(None, '成功', success_message)
        else:
            QMessageBox.information(None, '失敗', error_message)

    def generate_progress_bar(self, total, message):
        progress_message_bar = self.iface.messageBar().createMessage(message)
        progress_bar = QProgressBar()
        progress_bar.setMaximum(total)
        progress_bar.setAlignment(Qt.AlignHCenter | Qt.AlignVCenter)
        progress_message_bar.layout().addWidget(progress_bar)
        self.iface.messageBar().pushWidget(progress_message_bar, Qgis.MessageLevel(0))
        return progress_bar

    def remove_tmp_files(self):
        tmp_files = glob.glob(f"{self.tmp_file_folder}/*")
        for tmp_file in tmp_files:
            os.remove(tmp_file)
    
    def remove_base_map_layer(self):
        base_map_layers = QgsProject.instance().mapLayersByName('ベースマップ')
        if len(base_map_layers) != 0:
            base_map_layer = base_map_layers[0]
            base_map_layer.triggerRepaint()
            QgsProject.instance().removeMapLayer(base_map_layer)

    def is_existed_base_map_layer(self):
        base_map_layers = QgsProject.instance().mapLayersByName('ベースマップ')
        if len(base_map_layers) > 0:
            return True
        else:
            return False

    def check_base_map_layer(self, state):
        if Qt.Checked == state and not self.is_existed_base_map_layer():
            self.dlg.base_map_form.show()

            select_base_map_layer_name = self.dlg.base_map_form.currentText()
            base_map_layer_url = self.base_map_urls[select_base_map_layer_name]
            mts_layer = QgsRasterLayer(f"type=xyz&url={base_map_layer_url}", "ベースマップ", "wms")
            root = QgsProject.instance().layerTreeRoot()
            QgsProject.instance().addMapLayer(mts_layer, False)
            root.addLayer(mts_layer)
        elif Qt.Checked == state and self.is_existed_base_map_layer():
            current_base_map_layers = QgsProject.instance().mapLayersByName('ベースマップ')
            current_base_map_url = parse.unquote(current_base_map_layers[0].metadataUri().split("=")[-1])
            current_base_map_type = [base_map_type for base_map_type, base_map_url in self.base_map_urls.items() if base_map_url == current_base_map_url][0]
            base_map_types = list(self.base_map_urls.keys())
            self.dlg.base_map_form.setCurrentIndex(base_map_types.index(current_base_map_type))

            self.dlg.base_map_form.show()
        else:
            self.dlg.base_map_form.hide()
            self.remove_base_map_layer()

    def change_base_map_layer(self):
        self.remove_base_map_layer()

        select_base_map_layer_name = self.dlg.base_map_form.currentText()
        select_base_map_layer_url = self.base_map_urls[select_base_map_layer_name]
        mts_layer = QgsRasterLayer(f"type=xyz&url={select_base_map_layer_url}", "ベースマップ", "wms")
        root = QgsProject.instance().layerTreeRoot()
        QgsProject.instance().addMapLayer(mts_layer, False)
        root.addLayer(mts_layer)

    def list_fourdlink_projects(self):
        project_names = fetch_projects(self.access_token)
        self.dlg.project_name_form.clear()
        self.dlg.project_name_form.addItems(project_names)

        self.select_project_id = project_names[0].split(":")[0]
        self.layer_group_dataset_tree = fetch_group_dataset_by_project(self.access_token, self.select_project_id)

        self.list_layer_groups()
        self.list_datasets()

    def list_layer_groups(self):
        layer_group_items = list(self.layer_group_dataset_tree.keys())
        self.dlg.layer_group_form.clear()
        self.dlg.layer_group_form.addItems(layer_group_items)

    def list_datasets(self):
        current_layer_group = self.dlg.layer_group_form.currentText()
        if current_layer_group != '':
            self.dlg.dataset_form.clear()
            self.dlg.dataset_form.addItems(self.layer_group_dataset_tree[current_layer_group])

    def authenticate_fetch_projects(self):
        input_client_id = self.dlg.client_id_form.text()
        input_client_secret = self.dlg.client_secret_form.text()
        if input_client_id == '' or input_client_secret == '':
            QMessageBox.information(None, '認証', 'クライアントIDまたはクライアントの秘密が入力されていません。')
            return
        
        access_token = fetch_access_token(input_client_id, input_client_secret)
        
        if access_token is None:
            QMessageBox.information(None, '認証', 'クライアントIDまたはクライアントの秘密に誤りがあるか、\n有効期限が過ぎています。')
            return
    
        self.access_token = access_token
        self.list_fourdlink_projects()

    def change_projects(self):
        current_project_id = self.dlg.project_name_form.currentText().split(":")[0]
        self.layer_group_dataset_tree = fetch_group_dataset_by_project(self.access_token, current_project_id)
        self.list_layer_groups()
        self.list_datasets()

    def list_current_qgis_layers(self):
        self.dlg.layer_form.clear()
        layers = list(QgsProject.instance().mapLayers().values())
        layer_names_without_basemap = []
        for layer in layers:
            if layer.name() != 'ベースマップ':
                layer_names_without_basemap.append(layer.name())
        self.dlg.layer_form.addItems(layer_names_without_basemap)
 
    def change_layer_group(self):
        if self.dlg.layer_group_form.currentText() != '':
            select_layer_group_id = int(self.dlg.layer_group_form.currentText().split(":")[0])
            self.select_layer_group_id = select_layer_group_id
            print('change layer group', self.select_layer_group_id)
            self.select_folder_id = fetch_folder(self.access_token, self.select_layer_group_id)

    def change_dataset(self):
        if self.dlg.dataset_form.currentText() != '':
            select_dataset_id = int(self.dlg.dataset_form.currentText().split(":")[0])
            self.select_dataset_id = select_dataset_id

    def upload_file(self, dataset_id, upload_file, total_file_size, sequence, offset, chunk, is_last='true'):
            file_size = total_file_size
            dataset_url = f"https://app.4dlink.com/api/Dataset/{dataset_id}.chunked/data?seq={sequence}&offset={offset}&length={file_size}&chunk={chunk}&last={is_last}"
            headers = {
                'Authorization': f'Bearer {self.access_token}',
                'Content-Type': 'application/octet-stream'
            }
            response = requests.post(dataset_url, data=upload_file, headers=headers)
            return response

    def import_dataset_to_qgis(self):
        if self.valid_empty_form(self.dlg.dataset_form, 
                                '取り込み', 
                                'データセットが選択されていません。\n選択してから取り込んでください。'):
            return

        self.select_dataset_id = self.dlg.dataset_form.currentText().split(":")[0]
        dataset_content = fetch_dataset_file(self.access_token, self.select_dataset_id)

        select_dataset_name = self.dlg.dataset_form.currentText().split(":")[1]
        user_folder = Path(self.tmp_file_folder)
        tmp_file_path = str(user_folder / select_dataset_name)

        with open(tmp_file_path, 'wb') as f:
            f.write(dataset_content)
        mime_type, _ = mimetypes.guess_type(tmp_file_path)

        if mime_type is not None and mime_type.startswith("image"):
            layer = QgsRasterLayer(tmp_file_path, select_dataset_name.split(".")[0])
        else:
            layer = QgsVectorLayer(tmp_file_path, select_dataset_name.split(".")[0], "ogr")
        QgsProject.instance().addMapLayer(layer)

    def upload(self):
        if self.valid_empty_form(self.dlg.layer_form, 
                            'アップロード', 
                            'アップロード対象のレイヤーが選択されていません。\n選択してからアップロードしてください。'):
            return
        # https://gdal.org/drivers/vector/index.html
        ogr_driver_file_extension_map = {
            'LIBKML': 'kmz',
            'GeoJSON': 'json',
            "ESRI Shapefile": '',
            "GTiff": 'tif'
        }
        select_layer_name = self.dlg.layer_form.currentText()
        select_layer = QgsProject.instance().mapLayersByName(select_layer_name)[0]
        user_folder = Path(self.tmp_file_folder)

        self.select_layer_group_id = self.dlg.layer_group_form.currentText().split(":")[0]
        select_folder_id = fetch_folder(self.access_token, self.select_layer_group_id)
        self.select_folder_id = select_folder_id

        if isinstance(select_layer, QgsRasterLayer):
            pipe = QgsRasterPipe()
            provider = select_layer.dataProvider()
            if not pipe.set(provider.clone()):
                return
            file_name = f"{select_layer_name}.tif"
            tmp_file_path = user_folder / file_name
            raster_writer = QgsRasterFileWriter(str(tmp_file_path))
            raster_writer.writeRaster(
                pipe,
                provider.xSize(),
                provider.ySize(),
                provider.extent(),
                provider.crs(),
                QgsProject.instance().transformContext()
            )
            dataset_id = create_dataset(self.access_token, file_name, self.select_folder_id)
            self.select_dataset_id = dataset_id
            tmp_file_path_str = str(tmp_file_path)
        else:
            driver_type = select_layer.storageType()
            transform_context = QgsProject.instance().transformContext()
            save_options = QgsVectorFileWriter.SaveVectorOptions()
            save_options.symbologyExport = QgsVectorFileWriter.FeatureSymbology
            save_options.driverName = driver_type

            if driver_type == 'ESRI Shapefile':
                file_name = select_layer_name
            else:
                file_name = f"{select_layer_name}.{ogr_driver_file_extension_map.get(driver_type)}"

            tmp_file_path = user_folder / file_name

            QgsVectorFileWriter.writeAsVectorFormatV3(select_layer, str(tmp_file_path), transform_context, save_options)

            if driver_type == 'ESRI Shapefile':
                dataset_id = create_dataset(self.access_token, f"{file_name}.zip", self.select_folder_id)
            else:
                dataset_id = create_dataset(self.access_token, file_name, self.select_folder_id)
    
            self.select_dataset_id = dataset_id

            if driver_type == 'GeoJSON':
                tmp_file_path_str = str(tmp_file_path) + '.geojson'
            elif driver_type == 'ESRI Shapefile':
                tmp_file_path_str = str(tmp_file_path) + '.zip'
            else:
                tmp_file_path_str = str(tmp_file_path)
    
            if driver_type == 'ESRI Shapefile':
                with ZipFile(tmp_file_path_str, 'w') as shape_zip:
                    select_layer_name = select_layer_name.replace(".shp", "")
                    base_file_name = user_folder / select_layer_name
                    shape_zip.write(f"{str(base_file_name)}.dbf", f"{select_layer_name}.dbf")
                    shape_zip.write(f"{str(base_file_name)}.prj", f"{select_layer_name}.prj")
                    shape_zip.write(f"{str(base_file_name)}.shp", f"{select_layer_name}.shp")
                    shape_zip.write(f"{str(base_file_name)}.shx", f"{select_layer_name}.shx")

        chunk_size = 19 * (10 ** 6)
        file_size = os.path.getsize(tmp_file_path_str)

        if chunk_size < file_size:
            chunk_num = ceil(file_size / chunk_size)
            progress_bar = self.generate_progress_bar(chunk_num, 'アップロード中')
            offset = 0
            with open(tmp_file_path_str, 'rb') as f:
                final_response = None
                for sequence in range(chunk_num):
                    chunked_data = f.read(chunk_size)
                    if sequence == chunk_num - 1:
                        final_response = self.upload_file(self.select_dataset_id, chunked_data, file_size, 
                                        sequence, offset, chunk_size, 'true')
                    else:
                        self.upload_file(self.select_dataset_id, chunked_data, file_size, 
                                        sequence, offset, chunk_size, 'false')
                    offset += chunk_size
                    progress_bar.setValue(sequence + 1)
                self.iface.messageBar().clearWidgets()  
                self.show_message_by_response(final_response, 
                                              'アップロードに成功しました',
                                              'アップロードに失敗しました。')
        else:
            with open(tmp_file_path_str, 'rb') as f:            
                full_file = f.read()
                response = self.upload_file(self.select_dataset_id, full_file, file_size, 
                                0, 0, chunk_size, 'true')
                self.show_message_by_response(response, 
                                              'アップロードに成功しました',
                                              'アップロードに失敗しました。')